package pfc.bean;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;

/** pfc.bean.CombinacioBean
 * 
 * Representa un combinacio: un resultat d'hotel i un resultat de vol
 * 
 */
@XmlType(propOrder = {"formatPreu","hotelBean","flightBean"})
public class CombinacioBean implements Comparable<CombinacioBean> {

	@XmlElement(name= "hotel")
	private ItemBean hotelBean = null;
	@XmlElement(name= "vol")
	private ItemBean flightBean = null;

	public CombinacioBean(ItemBean hotelBean, ItemBean flightBean)
	{
		this.hotelBean = hotelBean;
		this.flightBean = flightBean;
	}

	public CombinacioBean()	{}

	public float getPreu() {
		return hotelBean.getPreu() + flightBean.getPreu();
	}
	
	@XmlElement(name= "preu")
	public String getFormatPreu() {
		return pfc.conf.Util.formatPreu(this.getPreu());
	}

	/* (non-Javadoc)
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(CombinacioBean combinacioBean) {
		if (this.getPreu() > combinacioBean.getPreu()) return 1;
		if (this.getPreu() < combinacioBean.getPreu()) return -1;
		return 0;
	}

	/**
	 * Informacio de debug a un fitxer HTML
	 * @return Informacio en format HTML de la combinacio
	 */
	public String toDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<div style='border: solid 1px black;'>PREU TOTAL: "+getPreu()+"</div>\n");
		sb.append("<div style='border: solid 1px black;'>"+hotelBean.toDebugHTML()+"</div>\n");
		sb.append("<div style='border: solid 1px black;'>"+flightBean.toDebugHTML()+"</div>\n");
		return sb.toString();
	}

}