package pfc.bean.flight;

import java.util.Vector;
import pfc.BeanPeticioConsulta;

/** pfc.bean.flight.LastminuteBean
 * 
 * Item resultat de l'operador lastminute
 */
public class LastminuteBean extends FlightBean {

	//Preu adult (obligatori)
	private String preuAdult = null;
	//Preu nin (opcional)
	private String preuNin = null;
	//Preu bebe (opcional)
	private String preuBebe = null;
	//anades (obligatori, pero si la expressio regular canvia pot no retornar resultats)
	//Cada anada = [companyia, id vol, data sortida, data arrivada]
	private Vector<String[]> anades = null;
	//tornades (obligatori, pero si la expressio regular canvia pot no retornar resultats)
	//Cada tornada = [companyia, id vol, data sortida, data arrivada]
	private Vector<String[]> tornades = null;

	public LastminuteBean(BeanPeticioConsulta beanPeticioConsulta) {
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		float preuAdult = Float.valueOf(this.preuAdult.replace(",","."));
		float preuNin = this.preuNin==null?0:Float.valueOf(this.preuNin.replace(",","."));
		float preuBebe = this.preuBebe==null?0:Float.valueOf(this.preuBebe.replace(",","."));
		return 
			preuAdult * beanPeticioConsulta.getNumTotalAdults(12) +
			preuNin * beanPeticioConsulta.getNumTotalPax(2,11) +
			preuBebe * beanPeticioConsulta.getNumTotalBebes(1);
	}

	protected String getDebugHTML() {	
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Preu adult: '" + this.preuAdult + "'</span><br />");
		sb.append("<span>Preu nin: '" + this.preuNin + "'</span><br />");
		sb.append("<span>Preu bebe: '" + this.preuBebe + "'</span><br />");
		sb.append("<span>Anades:");
		for (String[] anada: anades) {
			sb.append("<br />[");
			for (int j=0; j<anada.length; j++) sb.append((j>0?",":"")+"("+anada[j]+")");
			sb.append("]");
		}
		sb.append("</span><br />");
		sb.append("<span>Tornades:");
		for (String[] tornada: tornades) {
			sb.append("<br />[");
			for (int j=0; j<tornada.length; j++) sb.append((j>0?",":"")+"("+tornada[j]+")");
			sb.append("]");
		}
		sb.append("</span>");
		return sb.toString();
	}

	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		//Preus per tipus de passatger
		sb.append("<div><span class=\"s0\"></span><span>Es poden afegir tases de 8'5 per passatger</span></div>");
		if (this.preuAdult != null) {
			sb.append("<div><span class=\"s0\">Preu adult</span><span>" + this.preuAdult + "</span></div>");
		}
		if (this.preuNin != null) {
			sb.append("<div><span class=\"s0\">Preu nin</span><span>" + this.preuNin + "</span></div>");
		}
		if (this.preuBebe != null) {
			sb.append("<div><span class=\"s0\">Preu bebe</span><span>" + this.preuBebe + "</span></div>");
		}
		//Anades
		for (int i=1; i<=anades.size(); i++) {
			String[] anada = anades.get(i-1);
			sb.append("<div><span class=\"s0\">Anada " + i + "</span></div>");
			sb.append("<div><span class=\"s0\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Horari</span>");
			sb.append(anada[2]+" - "+anada[3]);
			sb.append("<div><span class=\"s0\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Companyia / vol(s)</span>");
			sb.append(anada[0]+" / "+anada[1]);
		}
		//Tornades
		for (int i=1; i<=tornades.size(); i++) {
			String[] tornada = tornades.get(i-1);
			sb.append("<div><span class=\"s0\">Tornada " + i + "</span></div>");
			sb.append("<div><span class=\"s0\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Horari</span>");
			sb.append(tornada[2]+" - "+tornada[3]);
			sb.append("<div><span class=\"s0\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Companyia / vol(s)</span>");
			sb.append(tornada[0]+" / "+tornada[1]);
		}
		return sb.toString();
	}

	public String getNomOperador() {
		return "lastminute.com";
	}
	public void setPreuAdult(String preuAdult) {
		this.preuAdult = preuAdult;
	}
	public void setPreuNin(String preuNin) {
		this.preuNin = preuNin;
	}
	public void setPreuBebe(String preuBebe) {
		this.preuBebe = preuBebe;
	}
	public void setAnades(Vector<String[]> anades) {
		this.anades = anades;
	}
	public void setTornades(Vector<String[]> tornades) {
		this.tornades = tornades;
	}
}