package pfc.bean.flight;

import pfc.BeanPeticioConsulta;

/** pfc.bean.flight.SpanairBean
 * 
 * Item resultat de l'operador Spanair
 */
public class SpanairBean extends FlightBean {

	//anada (obligatori)
	//format = [hora,ruta,duracio,escales,preu,preu adult, preu nin, preu infant, tases]
	private String[] anada;
	//tornada (obligatori)
	//format = [hora,ruta,duracio,escales,preu,preu adult, preu nin, preu infant, tases]
	private String[] tornada;

	public SpanairBean(BeanPeticioConsulta beanPeticioConsulta) {
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		float preuAdultAnada = anada[5] == null ? 0 : Float.valueOf(anada[5].toString().replace(",","."));
		float preuAdultTornada = tornada[5] == null ? 0 : Float.valueOf(tornada[5].toString().replace(",","."));
		float preuNinAnada = anada[6] == null ? 0 : Float.valueOf(anada[6].toString().replace(",","."));
		float preuNinTornada = tornada[6] == null ? 0 : Float.valueOf(tornada[6].toString().replace(",","."));
		float preuBebeAnada = anada[7] == null ? 0 : Float.valueOf(anada[7].toString().replace(",","."));
		float preuBebeTornada = tornada[7] == null ? 0 : Float.valueOf(tornada[7].toString().replace(",","."));
		float preuTasesAnada = anada[8] == null ? 0 : Float.valueOf(anada[8].toString().replace(",","."));
		float preuTasesTornada = tornada[8] == null ? 0 : Float.valueOf(tornada[8].toString().replace(",","."));
		
		int numAdults = this.beanPeticioConsulta.getNumTotalAdults(12);
		int numNins = this.beanPeticioConsulta.getNumTotalPax(2,11); 
		int numBebes = this.beanPeticioConsulta.getNumTotalBebes(1);
		return (preuAdultAnada + preuAdultTornada) * numAdults + 
			   (preuNinAnada + preuNinTornada) * numNins +
			   (preuBebeAnada + preuBebeTornada) * numBebes +
			   preuTasesAnada + preuTasesTornada;
	}

	protected String getDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Anada: '");
		for (int j=0; j<anada.length; j++) sb.append((j==0?"":",")+"("+anada[j]+")");
		sb.append("'</span><br />");
		sb.append("'<span>Tornada: '");
		for (int j=0; j<tornada.length; j++) sb.append((j==0?"":",")+"("+tornada[j]+")");
		sb.append("'</span>");
		return sb.toString();
	}

	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<div><span class=\"s0\">Ruta anada </span><span>" + anada[1] + "</span></div>");
		sb.append("<div><span class=\"s0\">Hora sortida anada</span><span>" + anada[0] + " (" + anada[3] + " escala/es)</span></div>");
		sb.append("<div><span class=\"s0\">Ruta tornada </span><span>" + tornada[1] + "</span></div>");
		sb.append("<div><span class=\"s0\">Hora sortida tornada</span><span>" + tornada[0] + " (" + tornada[3] + " escala/es)</span></div>");
		return sb.toString();
	}

	public String getNomOperador() {
		return "Spanair";
	}
	public void setAnada(String[] anada) {
		this.anada = anada;
	}
	public void setTornada(String[] tornada) {
		this.tornada = tornada;
	}

}