package pfc.bean.flight;

import java.util.Vector;

import pfc.BeanPeticioConsulta;

/** pfc.bean.flight.VuelingBean
 * 
 * Item resultat de l'operador Vueling
 */
public class VuelingBean extends FlightBean {

	//anada (obligatori)
	//format = [preu, preuBebe, data, hora, rutes(ciutats origen/desti)]
	private Object[] anada;
	//tornada (obligatori)
	//format = [preu, preuBebe, data, hora, rutes(ciutats origen/desti)]
	private Object[] tornada;

	public VuelingBean(BeanPeticioConsulta beanPeticioConsulta) {
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		int numPax = this.beanPeticioConsulta.getNumTotalAdults(12) + this.beanPeticioConsulta.getNumTotalPax(2,11);
		int numBebes = this.beanPeticioConsulta.getNumTotalBebes(1); 
		return 
			Float.valueOf(anada[0].toString().replace(",","."))*numPax +
			(anada[1]==null?0:Float.valueOf(anada[1].toString().replace(",","."))*numBebes) + 
			Float.valueOf(tornada[0].toString().replace(",","."))* numPax + 
			(tornada[1]==null?0:Float.valueOf(tornada[1].toString().replace(",","."))*numBebes);
	}

	@SuppressWarnings("unchecked")
	protected String getDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Anada: '");
		for (int j=0; j<anada.length-1; j++) sb.append((j==0?"":",")+"("+anada[j]+")");
		Vector<String[]> vRutesAnada = (Vector<String[]>)anada[anada.length-1];
		for (String[] ruta: vRutesAnada) {
			sb.append("("+ruta[0]+":"+ruta[1]+")");
		}
		sb.append("'</span><br />");
		sb.append("<span>Tornada: '");
		for (int j=0; j<tornada.length-1; j++) sb.append((j==0?"":",")+"("+tornada[j]+")");
		Vector<String[]> vRutesTornada = (Vector<String[]>)tornada[tornada.length-1];
		for (String[] ruta: vRutesTornada) {
			sb.append("("+ruta[0]+":"+ruta[1]+")");
		}
		sb.append("'</span>");
		return sb.toString();
	}

	@SuppressWarnings("unchecked")
	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		
		//Anada
		sb.append("<div><span class=\"s0\">Preu anada</span><span>"+anada[0]+"</span></div>");
		if (anada[1]!=null) {
			sb.append("<div><span class=\"s0\">Preu anada (bebe)</span><span>"+anada[1]+"</span></div>");
		}
		sb.append("<div><span class=\"s0\">Data anada</span><span>"+anada[2]+"</span></div>");
		Vector<String[]> vRutesAnada = (Vector<String[]>) anada[3];
		for (int i=1; i<=vRutesAnada.size(); i++) {
			sb.append("<div><span class=\"s0\">Ruta anada "+i+"</span><span>"+vRutesAnada.get(i-1)[0]+" - "+vRutesAnada.get(i-1)[1]+"</span></div>");
		}

		//Tornada
		sb.append("<div><span class=\"s0\">Preu tornada</span><span>"+tornada[0]+"</span></div>");
		if (anada[1]!=null) {
			sb.append("<div><span class=\"s0\">Preu anada (bebe)</span><span>"+tornada[1]+"</span></div>");
		}
		sb.append("<div><span class=\"s0\">Data tornada</span><span>"+tornada[2]+"</span></div>");
		Vector<String[]> vRutesTornada = (Vector<String[]>) tornada[3];
		for (int i=1; i<=vRutesTornada.size(); i++) {
			sb.append("<div><span class=\"s0\">Ruta tornada "+i+"</span><span>"+vRutesTornada.get(i-1)[0]+" - "+vRutesTornada.get(i-1)[1] + "</span></div>");
		}		

		return sb.toString();
	}
	
	public String getNomOperador() {
		return "vueling";
	}
	public void setAnada(Object[] anada) {
		this.anada = anada;
	}
	public void setTornada(Object[] tornada) {
		this.tornada = tornada;
	}

}