package pfc.bean.hotel;

import java.util.Vector;
import pfc.BeanPeticioConsulta;

/** pfc.bean.hotel.HotelopiaBean
 * 
 * Item resultat de l'operador Hotelopia
 */
public class HotelopiaBean extends HotelBean {

	//Categoria (opcional)
	private String categoria = null;
	//Descripcio (obligatori)
	private String descripcio = null;
	//Descripcio habitacions i regim (obligatori)
	private Vector<String> habitacions = null;

	public HotelopiaBean(BeanPeticioConsulta beanPeticioConsulta) {
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		return Float.valueOf(this.preu.replace(",","."));
	}

	protected String getDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Categoria: '" + this.categoria + "'</span><br />");
		sb.append("<span>Descripci: '" + this.descripcio + "'</span><br />");
		sb.append("<span>Habitacions: '" + this.habitacions + "'</span><br />");
		return sb.toString();
	}
	
	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		if (this.categoria!=null) sb.append("<div><span class=\"s0\">Categoria</span><span>" + this.categoria + "</span></div>");
		sb.append("<div><span class=\"s0\">Descripci</span><span>" + this.descripcio + "</span></div>");
		if (this.habitacions!=null) {
			for (int i=1; i<=this.habitacions.size(); i++) {
				sb.append("<div><span class=\"s0\">Habitacio " + i +"</span><span>" + this.habitacions.get(i-1) + "</span></div>");	
			}
		}
		return sb.toString();
	}

	public String getNomOperador() {
		return "Hotelopia";
	}
	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	public void setHabitacions(Vector<String> habitacions) {
		this.habitacions = habitacions;
	}
}