package pfc.bean.hotel;

import pfc.BeanPeticioConsulta;

/** pfc.bean.hotel.LastminuteBean
 * 
 * Item resultat de l'operador lastminute
 */
public class LastminuteBean extends HotelBean {

	//Zona (opcional)
	private String zona = null;
	//Categoria (obligatori)
	private String categoria = null;
	//Direccio (obligatori)
	private String direccio = null;
	//Descripcio (obligatori)
	private String descripcio = null;	
	
	public LastminuteBean(BeanPeticioConsulta beanPeticioConsulta) {
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		return Float.valueOf(this.preu.replace(",","."));
	}

	public String getDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Zona: '" + this.zona + "'</span><br />");
		sb.append("<span>Descripci: '" + this.descripcio + "'</span><br />");
		sb.append("<span>Categoria: '" + this.categoria + "'</span><br />");
		sb.append("<span>Direcci: '" + this.direccio + "'</span><br />");
		return sb.toString();
	}

	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<div><span class=\"s0\">Zona</span><span>" + this.zona + "</span></div>");
		sb.append("<div><span class=\"s0\">Descripci</span><span>" + this.descripcio + "</span></div>");
		sb.append("<div><span class=\"s0\">Categoria</span><span>" + this.categoria + "</span></div>");
		if (this.direccio.length()>0) sb.append("<div><span class=\"s0\">Direcci</span><span>" + this.direccio + "</span></div>");
		return sb.toString();
	}

	public String getNomOperador() {
		return "lastminute.com";
	}
	public void setZona(String zona) {
		this.zona = zona;
	}
	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}
	public void setDireccio(String direccio) {
		this.direccio = direccio;
	}
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
}