package pfc.bean.hotel;

import java.util.Vector;
import pfc.BeanPeticioConsulta;

/** pfc.bean.hotel.SkooshBean
 * 
 * Item resultat de l'operador Skoosh
 */
public class SkooshBean extends HotelBean {

	//Categoria (opcional)
	private String categoria = null;
	//Descripcio (obligatori)
	private String descripcio = null;
	//Descripcio de les habitacions (obligatori)
	private Vector<String> vDescHab = null;

	public SkooshBean(BeanPeticioConsulta beanPeticioConsulta){
		super(beanPeticioConsulta);
	}

	public float getPreu() {
		return Float.valueOf(this.preu.replace(",","."));  
	}

	public String getDebugHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<span>Categoria: '" + this.categoria + "'</span><br />");
		sb.append("<span>Descripci: '" + this.descripcio + "'</span><br />");
		sb.append("<span>Descripci habitacions: '" + this.vDescHab + "'</span><br />");
		return sb.toString();
	}
	
	public String getHTML() {
		StringBuffer sb = new StringBuffer();
		sb.append("<div><span class=\"s0\">Categoria</span><span>" + this.categoria + "</span></div>");
		sb.append("<div><span class=\"s0\">Descripci</span><span>" + this.descripcio + "</span></div>");
		if (this.vDescHab!=null) {
			for (int i=1; i<=vDescHab.size(); i++) {
				sb.append("<div><span class=\"s0\">Descripci habitaci " + i + "</span><span>" + this.vDescHab.get(i-1) + "</span></div>");
			}
		}
		return sb.toString();
	}

	public String getNomOperador() {
		return "Skosh";
	}
	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}
	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}
	public void setvDescHab(Vector<String> vDescHab) {
		this.vDescHab = vDescHab;
	}
}