package pfc.conf;

import java.text.SimpleDateFormat;

/** pfc.conf.Constants
 * Declaracio de constants globals de l'aplicacio
 */
public class Constants {

	//Fitxer de configuracio (properties)
	public static String PATH_PROPERTIES_LOG4J	= "log4j.properties";
	public static String PATH_PROPERTIES_CONFIG = "config.properties";

	//Nom de la plantilla XSLT (dins WEB-INF/classes)
	public static String PATH_XSLT = "resultat.xslt";

	//Constants de la peticio (restriccions del buscador a nivell dels valors dels parametres)
	public static int MAX_ROOMS = 5;
	public static int MAX_NITS = 20;
	public static int MAX_PAX = 9;
	public static int DEFAULT_EDAT_PAX = 30;
	public static int DEFAULT_EDAT_ADULT = 18;

	//PARAMETRITZACIO: Temps entre llanament de threads (cerques a operadors)
	public static int TIME_BETWEEN_STARTS = 500;

	//PARAMETRITZACIO: Cache de peticions http
	public static int CACHE_MAX_ENTRIES    = 500;
	public static int CACHE_MAX_OBJECTSIZE = 8192;  //(8KB)

	/*
	 * MISSATGES D'ERROR
	 */

	//Error peticio
	public static String MSG_ERROR_REQUEST_LIMITHABITACIONS = "No es possible seleccionar ms de cinc habitacions";
	public static String MSG_ERROR_DATA_INICI_INCORRECTA 	= "La data d'inici no es vlida (el dia no existeix)";
	public static String MSG_ERROR_DATA_FI_INCORRECTA 		= "La data de fi no es vlida (el dia no existeix)";
	public static String MSG_ERROR_DATES_ANTERIORS_AVUI		= "La data d'inici no es vlida (El viatge ha de comenar ms tard)";
	public static String MSG_ERROR_NITSNEGATIU 				= "La data de fi ha de ser posterior a la data d'inici";
	public static String MSG_ERROR_NITEXCEDIDES 			= "No es poden reservar ms de " + MAX_NITS + " nits";
	public static String MSG_ERROR_DATAINICITARD 			= "No pots reservar amb ms d'any i mig d'antelaci";
	public static String MSG_ERROR_CIUTATSIGUALS 			= "La ciutat de dest ha de ser diferent a la d'origen";
	public static String MSG_ERROR_AEROPORTSIGUALS 			= "Els aeroports d'origen i dest son els mateixos";
	public static String MSG_ERROR_SENSEHABITACIONS 		= "Has d'indicar qualque habitaci";
	public static String MSG_ERROR_PAXEXCEDITS 				= "No poden viatjar ms de " + MAX_PAX + " passatgers a una mateixa reserva";
	public static String MSG_ERROR_MINADULTS				= "Hi ha qualque habitaci sense adults";

	//Sense resultats
	public final static String MSG_ERROR_SENSE_RESULTATS	= "No s'ha trobat cap resultat per al filtre indicat";
	public final static String MSG_ERROR_SENSE_HOTELS 		= "No s'han trobat hotels a la ciutat de dest";
	public final static String MSG_ERROR_SENSE_VOLS   		= "No s'han trobat vols per a la combinaci indicada";

	//Caracter separador de directoris. Camp depenent de la plataforma d'execucio
	public static String FILE_SEP = System.getProperty("file.separator");

	//Constant format data
	public static SimpleDateFormat sDf = new SimpleDateFormat("dd-MM-yyyy");
}