package pfc.http;

import java.util.concurrent.TimeUnit;
import org.apache.http.conn.ClientConnectionManager;

	/**
	 * Thread que tanca connexions actives i expirades
	 *
	 */
	public class GestorConnexionsExpirades extends Thread {

        private final ClientConnectionManager connMgr;

        private volatile Thread blinker;

        public GestorConnexionsExpirades(ClientConnectionManager connMgr) {
            super();
            this.connMgr = connMgr;
        }

        @Override
        public void run() {
            try {
            	Thread thisThread = Thread.currentThread();
                while (thisThread == blinker) {
                        wait(5000);
                        // Tancar connexions expirades
                        connMgr.closeExpiredConnections();
                        // Opcionalment, tancar connexions inactives durant mes de 5 segons
                        connMgr.closeIdleConnections(5, TimeUnit.SECONDS);
                }
            } catch (InterruptedException ex) {
            }
        }

        public void shutdown() {
        	blinker = null;
        }

    }