package pfc.wrapper.flight.flights;

import java.io.IOException;
import java.util.Vector;

import org.apache.http.client.methods.HttpPost;
import org.apache.log4j.Level;

import pfc.bean.flight.EdreamsBean;
import pfc.bean.flight.FlightBean;
import pfc.exception.PeticioWrapperException;
import pfc.conf.Util;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.flight.flights.Edreams
 * 
 * Wrapper de l'operador eDreams
 */
public class Edreams extends pfc.wrapper.flight.WrapperFlight {

	public Edreams(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumTotalAdults(12)>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_ADULTS);
		if (this.beanPeticioConsulta.getNumTotalNins(12)>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_NINS);
		if (this.beanPeticioConsulta.getNumTotalBebes(1)>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_BEBES);
		if (this.beanPeticioConsulta.getNumTotalPax()>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_CAPACITAT);
	}

	protected String getCiutat(String ciutat) throws PeticioWrapperException {
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "9820";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "9631";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "9685";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "9707";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "9749";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "9845";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "1019722";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "2302";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "3030";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "9719";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "9762";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "1101";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "9830";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "9803";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "9853";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "5740";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "9847";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "9852";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "9837";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "9646";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "2615";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "9836";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "9629";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "9850";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "9730";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "9848";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "9854";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "9748";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "2954,";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "3034";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "3407";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "9801";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "9655";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.edreams.es/engine/ItinerarySearch/search?";	
		uri += "&buyPath=2";
		uri += "&auxOrBt=0";
		uri += "&searchMainProductTypeName=FLIGHT";
		uri += "&hasLiligoPopUnder=true";
		uri += "&liligoRatio=50";
		uri += "&websiteCode=ES";
		uri += "&dynArrivalCity=";
		uri += "&dynDepartureCity=";
		uri += "&dynDepartureDate=";
		uri += "&dynReturnDate=";		
		uri += "&dynDepartureTime=";
		uri += "&dynReturnTime=";
		uri += "&dynNumOfChildren=";
		uri += "&dynOnlyDirectFlight=";
		uri += "&dynNumOfAdults=";
		uri += "&dynNumOfRooms=";
		uri += "&country=ES";
		uri += "&language=es";
		uri += "&tripTypeName=ROUND_TRIP";
		uri += "&departureLocationGeoNodeId=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getOrigen()));
		uri += "&departureLocation=" + pfc.conf.Util.encode(this.beanPeticioConsulta.getOrigen());
		uri += "&arrivalLocationGeoNodeId=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getDesti()));
		uri += "&arrivalLocation=" + pfc.conf.Util.encode(this.beanPeticioConsulta.getDesti());
		uri += "&departureDate=" + this.getDataInici("dd/MM/yyyy");
		uri += "&departureDate=" + "0000"; //Flexibilitat en la data de sortida
		uri += "&returnDate=" + this.getDataFi("dd/MM/yyyy");
		uri += "&returnTime=" + "0000"; //Flexibilitat en la data d'arrivada
		uri += "&numAdults=" + this.beanPeticioConsulta.getNumTotalAdults(12);
		uri += "&numChilds=" + this.beanPeticioConsulta.getNumTotalPax(2,11);
		uri += "&numInfants=" + this.beanPeticioConsulta.getNumTotalBebes(1);
		uri += "&filteringCarrier=";
		uri += "&fake_filteringCarrier=Todas+las+compaias";
		uri += "&cabinClassName=TOURIST";
		uri += "&image=";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri);
		HttpPost peticio_1 = new HttpPost(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		//PETICIO 2 (opcional) -- Pregunta resident
		String titleResidente = Er.getOptionalValue("(Residentes</title)",resposta);
		if (titleResidente!=null) {
			uri = "http://www.edreams.es/engine/ItinerarySearch/resident?";
			uri += "&searchId="+Er.getValue("searchId\".*?value=\"(.*?)\"",resposta);
			uri += "&departureDate="+Er.getValue("departureDate\".*?value=\"(.*?)\"",resposta);
			uri += "&departureLocation="+Util.encode(Er.getValue("departureLocation\".*?value=\"(.*?)\"",resposta));
			uri += "&tripTypeName="+Er.getValue("tripTypeName\".*?value=\"(.*?)\"",resposta);
			uri += "&returnDate="+Er.getValue("returnDate\".*?value=\"(.*?)\"",resposta);
			uri += "&arrivalLocation="+Util.encode(Er.getValue("arrivalLocation\".*?value=\"(.*?)\"",resposta));
			uri += "&resident=false";
			HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri);
			HttpPost peticio_2 = new HttpPost(uri);
			resposta = httpClient.execute(peticio_2,responseHandler,httpContext);
		}

		resultatScraping = resposta;
	}

	protected void getScrapedItems(){
		Vector<FlightBean> vVolBean = new Vector<FlightBean>();

		Vector<String> items = Er.getValues("<form[^\n]*?id=\"itinerary.*?</form>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");

			pfc.util.FileUtil.printItemFlight(item, CLASS_NAME+"#item_" + indexItem + ".html");

			EdreamsBean edreamsBean = new EdreamsBean(beanPeticioConsulta);

			//PREU
			Vector<Vector<String>> digitsPreus = Er.getGroupValues("singleItinerayPrice.*?(\\d+)<.*?>(,\\d+)<",item);
			String preu = digitsPreus.get(0).get(0) + digitsPreus.get(0).get(1);
			edreamsBean.setPreu(preu);

			//DATES ANADA
			String anada = Er.getValueWithNL("IDA(.*?)VUELTA",item);

			String dataAnada = Er.getOptionalValueWithNL("itineraySegmentHeader2c.*?>(.*?)<",anada);
			if (dataAnada!=null) dataAnada = dataAnada.trim();
			edreamsBean.setDataAnada(dataAnada);

			Vector<String> timeTableItemsAnada = Er.getValues("<table.*?>(.*?)</table>",anada);
			Vector<String[]> anades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsAnada) {
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String ciutatOrigen = Er.getValueWithNL("<div.*?>(.*?)</div",columns.get(2).get(0));
				ciutatOrigen = ciutatOrigen.replaceAll("&nbsp;","").trim();

				String horaSortida = columns.get(1).get(0).trim();

				String ciutatDesti = Er.getValueWithNL("<div.*?>(.*?)</div",columns.get(4).get(0));
				ciutatDesti = ciutatDesti.replaceAll("&nbsp;","").trim();

				String horaArrivada = columns.get(3).get(0).trim();

				String companyia = columns.get(5).get(0);
				companyia = Er.replaceContentTagsAndTrim(companyia);

				String escales = Er.getOptionalValue(">\\s*(\\d+)\\s*<",columns.get(7).get(0));

				String[] dadaAnada = {ciutatOrigen,horaSortida,ciutatDesti,horaArrivada,companyia,escales};
				anades.add(dadaAnada);
			}
			edreamsBean.setAnades(anades);

			//DATES TORNADA
			String tornada = Er.getValueWithNL("VUELTA(.*)",item);

			String dataTornada = Er.getOptionalValueWithNL("itineraySegmentHeader2c.*?>(.*?)<",tornada);
			if (dataTornada!=null) dataAnada = dataTornada.trim();
			edreamsBean.setDataTornada(dataTornada);

			Vector<String> timeTableItemsTornada = Er.getValues("<table.*?>(.*?)</table>",tornada);
			Vector<String[]> tornades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsTornada) {
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String ciutatOrigen = Er.getValueWithNL("<div.*?>(.*?)</div",columns.get(2).get(0));
				ciutatOrigen = ciutatOrigen.replaceAll("&nbsp;","").trim();

				String horaSortida = columns.get(1).get(0).trim();
				
				String ciutatDesti = Er.getValueWithNL("<div.*?>(.*?)</div",columns.get(4).get(0));
				ciutatDesti = ciutatDesti.replaceAll("&nbsp;","").trim();

				String horaArrivada = columns.get(3).get(0).trim();

				String companyia = columns.get(5).get(0);
				companyia = Er.replaceContentTagsAndTrim(companyia);

				String escales = Er.getOptionalValue(">\\s*(\\d+)\\s*<",columns.get(7).get(0));
				
				String[] dadaTornada = {ciutatOrigen,horaSortida,ciutatDesti,horaArrivada,companyia,escales};
				tornades.add(dadaTornada);
			}
			edreamsBean.setTornades(tornades);

			//Insercio del registre al vector de resultats
			vVolBean.add(edreamsBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vVolBean);
	}

}