package pfc.wrapper.flight.flights;

import java.io.IOException;
import java.util.Calendar;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.log4j.Level;

import pfc.bean.flight.FlightBean;
import pfc.bean.flight.LastminuteBean;
import pfc.util.Er;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;

/** pfc.wrapper.flight.flights.Lastminute
 * 
 * Wrapper de l'operador lastminute
 */
public class Lastminute extends pfc.wrapper.flight.WrapperFlight  {
	
	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumTotalAdults(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_ADULTS);}
		if (this.beanPeticioConsulta.getNumTotalNins(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_NINS);}
		if (this.beanPeticioConsulta.getNumTotalBebes(1)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_BEBES);}
		if (this.beanPeticioConsulta.getNumTotalPax()>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_CAPACITAT);
		//Es revisen les dates doncs a l'url de cerca no s'envia l'any
		Calendar avui = Calendar.getInstance();
		Calendar dataFi = this.beanPeticioConsulta.getcHasta();
		if (dataFi.get(Calendar.YEAR)>avui.get(Calendar.YEAR)) {
			if (dataFi.get(Calendar.MONTH)>=avui.get(Calendar.MONTH)) {
				throw new PeticioWrapperException(PeticioWrapperException.RANG_DATES);
			}
		}
	}

	protected String getCiutat(String ciutat) throws PeticioWrapperException{
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Sevilla (SVQ), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria (LEI), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "Cordoba (ODB), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada (GRX), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga (AGP), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza (ZAZ), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca Pirineos (HSK), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo (OVD), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma De Mallorca (PMI), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza (IBZ), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Menorca (MAH), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Las Palmas (LPA), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Tenerife Norte (TFN), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander (SDR), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete (ABC), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos Villafria (RGS), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon (LEN), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca (SLM), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid (VLL), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona (BCN), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Gerona (GIRONA) (GRO), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia (VLC), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante (ALC), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz (BJZ), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "La Corua (LCG), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo (VGO), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid (MAD), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia (MJV), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Pamplona (PNA), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria (VIT), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian (EAS), ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao (BIO), ES";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.es.lastminute.com/site/viajes/vuelos/interstitial_page.html?";
		uri += "skin=eses.lastminute.com";
		uri += "&DPCAT=flights";
		uri += "&TRANS=ViewTransportationSearchBox,doSearchForTransportation";
		uri += "&DPCLS=X";
		uri += "&DPSAC=LA2";
		uri += "&DPDCC=EUR";
		uri += "&DPCID=0";
		uri += "&DPFIT=flights";
		uri += "&DPSRT=PA";
		uri += "&DPHSI=0";
		uri += "&DPHEI=9";
		uri += "&DPFSI=0";
		uri += "&DPFEI=10";
		uri += "&DPSFT=";
		uri += "&DPLOC=es_ES";
		uri += "&DPPID=0";
		uri += "&DPTRT=flights";
		uri += "&DPTTT=R";
		uri += "&DPDES=";
		uri += "&DPXIN=T";
		uri += "&DPXCH=T";
		uri += "&DPXTR=F";
		uri += "&DPXCP=F";
		uri += "&DPXAL=F";
		uri += "&DPXMG=F";
		uri += "&mondial_auto=false";
		uri += "&failureURL=http://www.es.lastminute.com/site/travel/flights/flights-search-error.html";
		uri += "&successURL=/travel/flights/transport-results.html";
		uri += "&DPAIR=NONE";
		uri += "&isEurostarSearch=False";
		uri += "&DP1WF=0";
		uri += "&DPDAP=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getOrigen()));
		uri += "&DPAAP=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getDesti()));
		uri += "&date_out_day=" + this.getDiaInici();
		uri += "&date_out_month=" + this.getMesInici();
		uri += "&DPODT=0001";
		uri += "&date_in_day=" + this.getDiaFi();
		uri += "&date_in_month=" + this.getMesFi();
		uri += "&DPIDT=0001";
		uri += "&DPNOA=" + this.beanPeticioConsulta.getNumTotalAdults(12);
		uri += "&DPNOS=0";
		uri += "&DPNOC=" + this.beanPeticioConsulta.getNumTotalPax(2,11);
		uri += "&DPNOI=" + this.beanPeticioConsulta.getNumTotalBebes(1);

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri);
		//peticio_1.setHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; es-AR; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		//PETICIO 2 (opcional)
		uri = Er.getOptionalValue("<meta http-equiv=\"Refresh\" content=\".;url=([^\"]*)\"",resposta);
		if (uri != null){
	    	uri = uri.replaceAll("&amp;", "&");
	    	dormir(5);
	    	HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
			HttpGet peticio_2 = new HttpGet(uri);
			resposta = httpClient.execute(peticio_2,responseHandler,httpContext);			
		}

		resultatScraping = resposta;
	}
	
	protected void getScrapedItems(){
		Vector<FlightBean> vVolBean = new Vector<FlightBean>();

		Vector<String> items = Er.getValues("<form[^\n]*?id=\"fare.*?</form>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");

			pfc.util.FileUtil.printItemFlight(item, CLASS_NAME+"#item_" + indexItem + ".html");

			LastminuteBean lastminuteBean = new LastminuteBean(beanPeticioConsulta);

			//preu adult
			String preuAdult = Er.getValueWithNL("por adulto.*?strong>(\\d+\\.\\d+)",item);
			lastminuteBean.setPreuAdult(preuAdult);

			//preu nin
			String preuNin = Er.getOptionalValueWithNL("por nio.*?strong>(\\d+\\.\\d+)",item);
			lastminuteBean.setPreuNin(preuNin);

			//preu bebe
			String preuBebe = Er.getOptionalValueWithNL("bebe.*?strong>(\\d+\\.\\d+)",item);
			lastminuteBean.setPreuBebe(preuBebe);

			//DATES ANADA
			String anada = Er.getValueWithNL("<table(.*?)class=\"inbound\".*?Vuelta",item);

			Vector<String> vNAnada = Er.getValues("<tbody>.*?</tbody>",anada);
			if (vNAnada.size()>0) {
				anada = "";
				for (String nAnada: vNAnada) {
					anada+=nAnada;
				}
			}

			Vector<String> timeTableItemsAnada = Er.getValues("<tr class=\"timings(?: separator)?\">.*?</tr",anada);
			
			Vector<String[]> anades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsAnada) {	
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String dadesCompanyia = columns.get(1).get(0).trim();
				String nomCompanyia = Er.getValueWithNL(">(.+?)</",dadesCompanyia);
				String idVol        = Er.trim(Er.getValueWithNL("br />(.+?)<br",dadesCompanyia));

				String dadesHorari = columns.get(2).get(0).trim();

				String dadesSortida = Er.getValueWithNL("Salida:(.+?)Llegada:",dadesHorari);
				String dataSortida  = Er.replaceTagsAndTrim(dadesSortida);

				String dadesArrivada = Er.getValueWithNL("Llegada:(.+)",dadesHorari);
				String dataArrivada  = Er.replaceTagsAndTrim(dadesArrivada);

				String[] dadaAnada = {nomCompanyia,idVol,dataSortida,dataArrivada};
				anades.add(dadaAnada);
			}
			lastminuteBean.setAnades(anades);

			//DATES TORNADA
			String tornada = "<tbody>"+Er.getValueWithNL("Vuelta(.*)</table>",item);

			Vector<String> vNTornada = Er.getValues("<tbody>.*?</tbody>",tornada);
			if (vNTornada.size()>0) {
				tornada = "";
				for (String nTornada: vNTornada) {
					tornada+=nTornada;
				}
			}

			Vector<String> timeTableItemsTornada = Er.getValues("<tr class=\"timings(?: separator)?\">.*?</tr",tornada);
			Vector<String[]> tornades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsTornada) {
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String dadesCompanyia = columns.get(1).get(0).trim();
				String nomCompanyia = Er.getValueWithNL(">(.+?)</",dadesCompanyia);
				String idVol        = Er.trim(Er.getValueWithNL("br />(.+?)<br",dadesCompanyia));

				String dadesHorari = columns.get(2).get(0).trim();

				String dadesSortida = Er.getValueWithNL("Salida:(.+?)Llegada:",dadesHorari);
				String dataSortida  = Er.replaceValue("<.*?>",dadesSortida,"").trim().replaceAll("\\s+"," ");

				String dadesArrivada = Er.getValueWithNL("Llegada:(.+)",dadesHorari);
				String dataArrivada  = Er.replaceValue("<.*?>",dadesArrivada,"").trim().replaceAll("\\s+"," ");

				String[] dadaTornada = {nomCompanyia,idVol,dataSortida,dataArrivada};
				tornades.add(dadaTornada);
			}
			lastminuteBean.setTornades(tornades);

			//Insercio del registre al vector de resultats
			vVolBean.add(lastminuteBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vVolBean);
	}

}