package pfc.wrapper.flight.flights;

import org.apache.http.client.methods.HttpPost;
import org.apache.log4j.Level;

import java.io.IOException;
import java.util.Vector;

import pfc.bean.flight.FlightBean;
import pfc.bean.flight.RumboBean;
import pfc.util.Er;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;

/** pfc.wrapper.flight.flights.Rumbo
 * 
 * Wrapper de l'operador Rumbo
 */
public class Rumbo extends pfc.wrapper.flight.WrapperFlight {

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumTotalAdults(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_ADULTS);}
		if (this.beanPeticioConsulta.getNumTotalNins(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_NINS);}
		if (this.beanPeticioConsulta.getNumTotalBebes(1)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_BEBES);}
		if (this.beanPeticioConsulta.getNumTotalPax()>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_CAPACITAT);
	}

	protected String getCiutat(String ciutat) throws PeticioWrapperException {
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Sevilla (SVQ)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria (LEI)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "Cordoba (ODB)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada (GRX)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga (AGP)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza (ZAZ)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca (HSK)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo, Asturias (OVD)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma de Mallorca (PMI)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza (IBZ)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Menorca (MAH)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Gran Canaria, Las Palmas (LPA)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Tenerife, (TCI)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander (SDR)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete, Los Llanos (ABC)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos, Villafria (RGS)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon, Leon (LEN)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca, Matacan (SLM)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid (VLL)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona, El Prat (BCN)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Gerona, Costa Brava (GRO)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia (VLC)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante (ALC)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz, Talaveral La Real (BJZ)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "La Corua, La Coruna (LCG)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo (VGO)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "Logroo, Agoncillo (RJL)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid, Barajas (MAD)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia, San Javier (MJV)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Pamplona (PNA)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria (VIT)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian (EAS)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao (BIO)";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.rumbo.es/viajes/vuelos/city.do?";
		uri += "buscadorWT-flight=Buscador+Home+Vuelos";
		uri += "&arrIata=" + this.getParamAeroport(this.beanPeticioConsulta.getDesti());
		uri += "&depIata=" + this.getParamAeroport(this.beanPeticioConsulta.getOrigen());
		uri += "&resultType=P";
		uri += "&from=";
		uri += "&onlyRenfe=";
		uri += "&promCode=";
		uri += "&flowType=";
		uri += "&it_mtp=A";
		uri += "&queryType=R";
		uri += "&depCity="	+ pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getOrigen()));
		uri += "&arrCity="	+ pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getDesti()));
		uri += "&depDate="	+ this.getDataInici("dd/MM/yyyy");
		uri += "&retDate="	+ this.getDataFi("dd/MM/yyyy");
		uri += "&paxAdt="	+ this.beanPeticioConsulta.getNumTotalAdults(12);
		uri += "&paxChd="	+ this.beanPeticioConsulta.getNumTotalPax(2,11);
		uri += "&paxInf="	+ this.beanPeticioConsulta.getNumTotalBebes(1);
		uri += "&cabin=";
		uri += "&train=false";
		uri += "&lowCost=true";
		uri += "&directOnly=false";
		uri += "&largeFamilyDiscountCode=";
		uri += "&residentDiscountCode=";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpPost peticio_1 = new HttpPost(uri);
		peticio_1.setHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; es-AR; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		dormir(7500);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.rumbo.es/viajes/vuelos/spider.do";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri);
		HttpPost peticio_2 = new HttpPost(uri);
		peticio_2.setHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; es-AR; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);

		resultatScraping = resposta;
	}

	protected void getScrapedItems(){
		Vector<FlightBean> vVolBean = new Vector<FlightBean>();

		Vector<String> items = Er.getValues("IDA:.+?boton_reservar.gif",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");

			pfc.util.FileUtil.printItemFlight(item, CLASS_NAME+"#item_" + indexItem + ".html");

			RumboBean rumboBean = new RumboBean(beanPeticioConsulta);

			//preu adult
			String preuAdult = Er.getValueWithNL("titular-grande\">(.+?)</td>",item);
			preuAdult = Er.replaceTagsAndTrim(preuAdult).replaceAll("&euro;| ", "");
			rumboBean.setPreuAdult(preuAdult);

			//preu total
			String overlib = Er.getValue("overlib(.*?)Desglose del precio<",item);
			String preu = Er.getValue("TOTAL.*?>(\\d+(?:,\\d+)?)&euro",overlib);
			rumboBean.setPreu(preu);

			//dates
			Vector<String> dates = Er.getValues("<td class=\"negro-bold-peke\">(.+?)</td>",item);
			String dataAnada = Er.replaceTagsAndTrim(dates.get(0));
			String dataTornada = Er.replaceTagsAndTrim(dates.get(1));
			rumboBean.setDataAnada(dataAnada);
			rumboBean.setDataTornada(dataTornada);

			//DATES ANADA
			Vector<String> timeTableItemsAnada = Er.getValues("id=\"capaIda.*?(<div.*?>.*?</div>.*?)*</div>",item);
			Vector<String[]> anades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsAnada) {
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String infoSortida = columns.get(0).get(0).trim();
				String horaSortida = Er.replaceTagsAndTrim(Er.getValueWithNL("horario-vuelos\">(.*?)</span",infoSortida));
				String ciutatSortida = Er.getValueWithNL("egro-bold\">.*?title=\'(.*?)\'",infoSortida);

				String infoArrivada = columns.get(1).get(0).trim();
				String horaArrivada = Er.replaceTagsAndTrim(Er.getValueWithNL("horario-vuelos\">(.*?)</span",infoArrivada));
				String ciutatArrivada = Er.getValueWithNL("egro-bold\">.*?title=\'(.*?)\'",infoArrivada);

				String infoCompanyia = columns.get(3).get(0).trim();
				infoCompanyia = Er.trim(Er.getValueWithNL("o-normal\">(.+?)<",infoCompanyia));

				String[] dadaAnada = {horaSortida,ciutatSortida,horaArrivada,ciutatArrivada,infoCompanyia};
				anades.add(dadaAnada);
			}
			rumboBean.setAnades(anades);

			//DATES TORNADA
			Vector<String> timeTableItemsTornada = Er.getValues("id=\"capaVuelta.*?(<div.*?>.*?</div>.*?)*</div>",item);
			Vector<String[]> tornades = new Vector<String[]>();
			for (String timeTableItem:timeTableItemsTornada) {
				Vector<Vector<String>> columns = Er.getGroupValues("<td.*?>(.*?)</td>",timeTableItem);

				String infoSortida = columns.get(0).get(0).trim();
				String horaSortida = Er.replaceTagsAndTrim(Er.getValueWithNL("horario-vuelos\">(.*?)</span",infoSortida));
				String ciutatSortida = Er.getValueWithNL("egro-bold\">.*?title=\'(.*?)\'",infoSortida);

				String infoArrivada = columns.get(1).get(0).trim();
				String horaArrivada = Er.replaceTagsAndTrim(Er.getValueWithNL("horario-vuelos\">(.*?)</span",infoArrivada));
				String ciutatArrivada = Er.getValueWithNL("egro-bold\">.*?title=\'(.*?)\'",infoArrivada);

				String infoCompanyia = columns.get(3).get(0).trim();
				infoCompanyia =  Er.trim(Er.getValueWithNL("o-normal\">(.+?)<",infoCompanyia));

				String[] dadaTornada = {horaSortida,ciutatSortida,horaArrivada,ciutatArrivada,infoCompanyia};
				tornades.add(dadaTornada);
			}
			rumboBean.setTornades(tornades);

			//Insercio del registre al vector de resultats
			vVolBean.add(rumboBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vVolBean);
	}

}