package pfc.wrapper.flight.flights;

import java.io.IOException;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.log4j.Level;

import pfc.bean.flight.FlightBean;
import pfc.bean.flight.SpanairBean;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.flight.flights.Spanair
 * 
 * Wrapper de l'operador Spanair
 */
public class Spanair extends pfc.wrapper.flight.WrapperFlight {

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumTotalAdults(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_ADULTS);}
		if (this.beanPeticioConsulta.getNumTotalNins(12)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_NINS);}
		if (this.beanPeticioConsulta.getNumTotalBebes(1)>9){ throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_BEBES);}
		if (this.beanPeticioConsulta.getNumTotalPax()>9) throw new PeticioWrapperException(PeticioWrapperException.MAX_TOTAL_CAPACITAT);
	}

	protected String getCiutat(String ciutat) throws PeticioWrapperException {
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA))		return "LCG";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "ALC";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA))	return "BCN";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO))		return "BIO";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "LPA";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA)) 	return "GRX";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "IBZ";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID))		return "MAD";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "AGP";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA))		return "PMI";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "MAH";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "OVD";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA)) 	return "SVQ";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE)) 	return "TCI";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "VLC";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "VGO";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;
		
		//Comprobacions de que les ciutats son valides
		//En cas de que no ho siguin, ens estalviam la primera crida HTTP
		getCiutat(this.beanPeticioConsulta.getOrigen());
		getCiutat(this.beanPeticioConsulta.getDesti());

		//PETICIO 1
		uri = "http://www.spanair.com";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.spanair.com/web/templates/Amadeus/_FramesetBuscador.aspx?";
		uri+= "__EVENTTARGET=";
		uri+= "&__EVENTARGUMENT=";
		uri+= "&__VIEWSTATE=" + Er.getValue("<input type=\"[^\"]*\" name=\"[^\"]*\" id=\"__VIEWSTATE\" value=\"([^\"]*)\"",resposta);
		uri+= "&IdZanox=";
		uri+= "&IdTradeDoubler=";
		uri+= "&IdNonstop=";
		uri+= "&URLReferer=/web/es-es/";
		uri+= "&PageNameOmniture=Inicio";
		uri+= "&BotonPulsado=V";
		uri+= "&language=es-es";
		uri+= "&configFile=http://www.spanair.com/xml/buscador/buscador-principal.xml";
		uri+= "&NumBonosGP100=0";
		uri+= "&tipoTrayecto=RT";
		uri+= "&selOrigenes=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getOrigen()));
		uri+= "&selDestinos=" + pfc.conf.Util.encode(getCiutat(this.beanPeticioConsulta.getDesti()));
		uri+= "&ctl00$PHBody$MultiBuscador1$BuscadorVuelos1$fecha_ida$bdpDate$textBox="     + this.getDataInici("dd-MM-yyyy");
		uri+= "&ctl00$PHBody$MultiBuscador1$BuscadorVuelos1$fecha_regreso$bdpDate$textBox=" + this.getDataFi("dd-MM-yyyy");
		uri+= "&dropAdultos=" + this.beanPeticioConsulta.getNumTotalAdults(12);
		uri+= "&dropNinos=" + this.beanPeticioConsulta.getNumTotalPax(2,11);
		uri+= "&dropBebes=" + this.beanPeticioConsulta.getNumTotalBebes(1);
		uri+= "&ctl00$PHBody$MultiBuscador1$LoginExcesoEquipajes$tbApellido=";
		uri+= "&ctl00$PHBody$MultiBuscador1$LoginExcesoEquipajes$tbLocalizador=";
		uri+= "&ORIGEN=";
		uri+= "&DESTINO=";
		uri+= "&version=";
		uri+= "&tipoViaje=";
		uri+= "&escalas=";
		uri+= "&maximo=";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri);
		HttpPost peticio_2 = new HttpPost(uri);
		peticio_2.addHeader("Content-Type","application/x-www-form-urlencoded");
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);

		dormir(2500);

		/* ********************************************** */
		//PETICIO 3
		uri = "http://book.spanair.com/pl/JKOnline/wds/Override.action?WDS_JS_TRACE_OFF";
		String params = "";
		params += "ENCT=1";
		params += "&SITE=BCTIBCTI";
		params += "&LANGUAGE=ES";
		params += "&EMBEDDED_TRANSACTION=FlexPricerAvailability";
		params += "&ENC=" + Er.getValue("<input value=\"([^\"]*)\" id=\"ENC\"",resposta);
		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri+params);

		HttpPost peticio_3 = new HttpPost(uri);
		StringEntity entity = new StringEntity(params,"UTF-8");
		peticio_3.setEntity(entity);
		peticio_3.addHeader("Content-Type","application/x-www-form-urlencoded");
		resposta = httpClient.execute(peticio_3,responseHandler,httpContext);

		resultatScraping = resposta;
	}

	protected void getScrapedItems(){
		Vector<FlightBean> vVolBean = new Vector<FlightBean>();

		Vector<String> items = Er.getValues("class=\"flights\">.*?</table>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		//Fragment script amb els preus individuals adult/nin/bebe
		String script = (Er.getValues("new Recommandation.*?</script>", resultatScraping)).get(0);

		//Dates anades
		int indexItem=0;
		Vector<String> vAnades = Er.getValues("tr id=\"flight.*?>.*?</tr",items.get(0));
		Vector<String[]> vItemsAnades = new Vector<String[]>();
		for (String anada: vAnades) {
			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item anada["+(++indexItem)+"/"+vAnades.size()+"]");
			pfc.util.FileUtil.printItemFlight(script+anada, CLASS_NAME+"#anada#item_" + indexItem + ".html");
			try {
				Vector<String> vCols = Er.getValues("<td.*?>.*?</td>",anada);
				String hora = Er.replaceTagsAndTrim(vCols.get(0));
				String ruta = Er.replaceTagsAndTrim(vCols.get(1));
				String duracio = Er.replaceTagsAndTrim(vCols.get(2));
				String escales = Er.getValueWithNL("(\\d+)</span",vCols.get(3));

				//Info preus
				String preu = Er.getValueWithNL("(\\d+)\\s*</span",vCols.get(4));
				String recoId = Er.getValue("(\\d+?)\\s*,\\s*this",vCols.get(4));
				String scriptFragment = Er.getValueWithNL("(Recommandation\\("+recoId+".*?)addRecommandation",script);
				String preuAdult = Er.getOptionalValue("addPassenger\\('ADT',\\s*'(.*?)'", scriptFragment);
				String preuNin = Er.getOptionalValue("addPassenger\\('CHD',\\s*'(.*?)'", scriptFragment);
				String preuBebe = Er.getOptionalValue("addPassenger\\('INF',\\s*'(.*?)'", scriptFragment);
				String preuTases = Er.getOptionalValue("PnrTaxes\\('(.*?)'", scriptFragment);

				vItemsAnades.add(new String[] {hora,ruta,duracio,escales,preu,preuAdult,preuNin,preuBebe,preuTases});
			}
			catch (java.lang.IllegalStateException ise) {
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item anada["+(indexItem)+"] without data");
			}
		}

		//Dates tornades
		indexItem=0;
		Vector<String> vTornades = Er.getValues("tr id=\"flight.*?>.*?</tr",items.get(1));
		Vector<String[]> vItemsTornades = new Vector<String[]>();
		for (String tornada: vTornades) {
			try {
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item tornada["+(++indexItem)+"/"+vTornades.size()+"]");
				pfc.util.FileUtil.printItemFlight(script+tornada, CLASS_NAME+"#tornada#item_" + indexItem + ".html");
				Vector<String> vCols = Er.getValues("<td.*?>.*?</td>",tornada);
				String hora = Er.replaceTagsAndTrim(vCols.get(0));
				String ruta = Er.replaceTagsAndTrim(vCols.get(1));
				String duracio = Er.replaceTagsAndTrim(vCols.get(2));
				String escales = Er.getValueWithNL("(\\d+)</span",vCols.get(3));

				//Info preus
				String preu = Er.getValueWithNL("(\\d+)\\s*</span",vCols.get(4));
				String recoId = Er.getValue("(\\d+?)\\s*,\\s*this",vCols.get(4));
				String scriptFragment = Er.getValueWithNL("(Recommandation\\("+recoId+".*?)addRecommandation",script);
				String preuAdult = Er.getOptionalValue("addPassenger\\('ADT',\\s*'(.*?)'", scriptFragment);
				String preuNin = Er.getOptionalValue("addPassenger\\('CHD',\\s*'(.*?)'", scriptFragment);
				String preuBebe = Er.getOptionalValue("addPassenger\\('INF',\\s*'(.*?)'", scriptFragment);
				String preuTases = Er.getOptionalValue("PnrTaxes\\('(.*?)'", scriptFragment);

				vItemsTornades.add(new String[] {hora,ruta,duracio,escales,preu,preuAdult,preuNin,preuBebe,preuTases});
			}
			catch (java.lang.IllegalStateException ise) {
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item tornada["+(indexItem)+"] without data");
			}
		}

		//Combinacions
		for (String[] anada: vItemsAnades) {
			for (String[] tornada: vItemsTornades) {
				SpanairBean spanairBean = new SpanairBean(beanPeticioConsulta);
				spanairBean.setAnada(anada);
				spanairBean.setTornada(tornada);
				vVolBean.add(spanairBean);
			}			
		}

		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vVolBean);
	}

}