package pfc.wrapper.hotel.hotels;

import java.io.IOException;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.log4j.Level;

import pfc.bean.ItemBean;
import pfc.bean.hotel.GetaroomBean;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.hotel.hotels.Getaroom
 * 
 * Wrapper de l'operador getaroom
 */
public class Getaroom extends pfc.wrapper.hotel.WrapperHotel {

	public Getaroom(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumHabitacions()>8)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ROOM);
		if (this.beanPeticioConsulta.getMaxAdults()>8)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ADULTS);
		if (this.beanPeticioConsulta.getMaxNins()>8)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_NINS);
	}

	protected String getCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Sevilla, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma De Mallorca, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Mahon, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Las Palmas, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Santa Cruz de Tenerife, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Girona, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "La Coruna, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "Logrono, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Pamplona, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian - Donostia, ES";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao, ES";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.getaroom.com/?currency=EUR";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri );
		//Sense aquesta capalera no es poden visualitzar els preus en euros (es mostren en dolars)
		peticio_1.setHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; es-AR; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.getaroom.com/searches/show?";
		uri += "sort_order=price";
		uri += "&page=1";
		uri += "&amenities[]=";
		uri += "&property_name=";
		uri += "&lucky=true";
		uri += "&destination=" + pfc.conf.Util.encode(this.getCiutat());
		uri += "&search[destination]=m19";
		uri += "&check_in=" + this.getDataInici("MM/dd/yyyy");
		uri += "&check_out=" + this.getDataFi("MM/dd/yyyy");
		int numHabitacions = this.beanPeticioConsulta.getNumHabitacions();
		uri += "&rinfo=" + "[";
		for (int i=0; i<numHabitacions; i++){
			if (i>0) uri += ",";
			uri += "[";
			for (int j=0; j<this.beanPeticioConsulta.getNumAdultsHabitacio(i); j++) {
				if (j>0) uri+= ",";
				uri += "18";
			}
			for (int j=0; j<this.beanPeticioConsulta.getNumNinsHabitacio(i); j++) {
				uri += "," + this.beanPeticioConsulta.getEdatNin(i,j);
			}
			uri += "]";
		}
		uri += "]";
		uri += "&commit=GO";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_2 = new HttpGet(uri);
		//Apany per a poder consultar els preus en euros
		peticio_2.setHeader("User-Agent", "Mozilla/5.0 (Windows; U; Windows NT 5.1; es-AR; rv:1.9.2.16) Gecko/20110319 Firefox/3.6.16");
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 3
		uri = Er.getOptionalValueWithNL("<meta http-equiv=\"refresh\" content=\".;URL=([^\"]*)\"",resposta);
		if (uri!=null) {
			uri = uri.replaceAll("&amp;", "&");
			HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
			HttpGet peticio_3 = new HttpGet(uri);
			resposta = httpClient.execute(peticio_3,responseHandler,httpContext);
		}

		resultatScraping = resposta;
	}

	protected void getScrapedItems(){
		Vector<ItemBean> vHotelBean = new Vector<ItemBean>();

		Vector<String> items = Er.getValues("<li class=\"searchresult\">.*?(<li.*?>.*?</li.*?>.*?)*</li>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem = 0;
		if (items.size()>0)
		{
			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items 1 length '"+items.size()+"'");
			for (String item: items){
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");
				pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

				GetaroomBean getaroom = new GetaroomBean(beanPeticioConsulta);

				//Nom hotel
				String nomHotel = Er.getValueWithNL("<h1><a.*?>(.+?)</h1>",item);
				nomHotel = Er.replaceTagsAndTrim(nomHotel);
				getaroom.setNomHotel(nomHotel);

				//Descripcio
				String descripcio = Er.getOptionalValueWithNL("description.*?>(.*?)</div",item);
				if (descripcio!=null) {
					descripcio = descripcio.replaceAll("<span>|</span>","");
					Vector<String> vHrefs = Er.getValues("href=\"(.*?)\"",descripcio,1);
					for (String href: vHrefs){
						//Escapament de caracters especials que poden formar part d'expressions regulars
						href=href.replaceAll("\\?","\\\\?");
						descripcio = descripcio.replaceAll(href, "http://res99.com"+href);
					}
					getaroom.setDescripcio(descripcio.trim());
				}

				//Preu
				String itemPreu = Er.getValueWithNL("\"price.*?>(.*?)EUR",item);
				String preu = Er.getOptionalValue("<b>(\\d+)</b>",itemPreu);
				if (preu == null) {
					loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]: SOLD OUT");
					continue;
				}
				getaroom.setPreu(preu);

				//Insercio del registre al vector de resultats
				vHotelBean.add(getaroom);
			}
		}
		else
		{
			items = Er.getValues("<li id=\"property.*?>.*?</li>",resultatScraping);
			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items 2 length '"+items.size()+"'");
			for (String item: items){
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");
				pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

				GetaroomBean getaroom = new GetaroomBean(beanPeticioConsulta);

				//Nom hotel
				String nomHotel = Er.getValueWithNL("result-property-information.*?<a.*?>(.+?)</a>",item);
				nomHotel = Er.replaceTagsAndTrim(nomHotel);
				getaroom.setNomHotel(nomHotel);

				//Descripcio
				String descripcio = Er.getValueWithNL("<p class=\"info\">(.+?)</p>",item);
				descripcio = descripcio.replaceAll("<span>|</span>","");
				Vector<String> vHrefs = Er.getValues("href=\"(.*?)\"",descripcio,1);
				for (String href: vHrefs){
					//Escapament de caracters especials que poden formar part d'expressions regulars
					href=href.replaceAll("\\?","\\\\?");
					descripcio = descripcio.replaceAll(href, "http://res99.com"+href);
				}
				getaroom.setDescripcio(descripcio.trim());

				//Preu
				String preu = Er.getValueWithNL("<span class=\"(?:discounted-)?price\">(.+?)</span>",item);
				getaroom.setPreu(preu.trim().replaceAll("&euro;",""));			

				//Insercio del registre al vector de resultats
				vHotelBean.add(getaroom);
			}
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vHotelBean);
	}

}