package pfc.wrapper.hotel.hotels;

import java.io.IOException;
import java.util.Calendar;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.log4j.Level;

import pfc.bean.hotel.HotelBean;
import pfc.bean.hotel.HotelesdotcomBean;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.hotel.hotels.Hotelesdotcom
 * 
 * Wrapper de l'operador hoteles.com
 */
public class Hotelesdotcom extends pfc.wrapper.hotel.WrapperHotel {
	
	public Hotelesdotcom(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumHabitacions()>8)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ROOM);
		if (this.beanPeticioConsulta.getMaxAdults()>8)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ADULTS);
		if (this.beanPeticioConsulta.getMaxNins()>3)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_NINS);
	}

	protected String getCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Sevilla, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "Cordoba, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga, Espaa (Malaga)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma de Mallorca, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Maho, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Las Palmas de Gran Canaria, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Tenerife, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon, Espaa (Leon)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Girona, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "A Corua, Espaa (La Corua)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "Logroo, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Vitoria, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria, Spain";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian, Espaa";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao, Espaa";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}
	
	private String getCodiCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "447112";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "462043";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "448718";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "441859";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "444849";		
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "466128";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "445461";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "466882";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "1633753";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "466941";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "441994";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "1634241";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "445723";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "464823";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "449895";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "445679";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "1636429";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "462776";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "448475";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "444495";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "1633509";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "465941";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "1636136";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "447220";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "457467";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "450953";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "456357";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "457987";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "467168";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "450754";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "463002";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "462921";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "458094";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	/** Retorna una plana de resultats doncs aquests es van pintant amb javascript. 
	 * Es captura l'enlla i es crida a fi de tenir carregats els resultats d'una mateixa plana.
	 * @param resposta
	 * @return HTML capturat
	 * @throws java.io.IOException
	 */
	private String getCompletePage(String resposta) throws java.io.IOException {
		String resultat = resposta;
		String uri = null;
		String next = Er.getOptionalValue("<div class=\"see_more_results js_hidden\">[ \n]*<a href=\"([^\"].*?)\"",resultat);
		while (next!=null){
			uri = "http://www.hoteles.com/" + next;

			HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
			HttpGet peticio_plana = new HttpGet(uri);
			resultat = httpClient.execute(peticio_plana,responseHandler,httpContext);
			next = Er.getOptionalValue("<div class=\"see_more_results js_hidden\">[ \n]*<a href=\"([^\"].*)\"",resultat);
		}
		return resultat;
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.hoteles.com/search.do?";
		uri += "destination=" + pfc.conf.Util.encode(getCiutat());
		uri += "&searchParams.arrivalDate=" + getDataInici("dd/MM/yyyy");
		uri += "&searchParams.departureDate=" + getDataFi("dd/MM/yyyy");
		int numHabitacions = this.beanPeticioConsulta.getNumHabitacions();
		uri += "&rooms="+String.valueOf(this.beanPeticioConsulta.getNumHabitacions());
		for (int i=0; i<numHabitacions; i++){
			uri += "&searchParams.rooms["+i+"].numberOfAdults="+this.beanPeticioConsulta.getNumAdultsHabitacio(i);
			uri += "&children["+i+"]="+this.beanPeticioConsulta.getNumNinsHabitacio(i);
			int numChildren = this.beanPeticioConsulta.getNumNinsHabitacio(i);
			for (int j=0; j<numChildren; j++){
				uri += "&searchParams.rooms["+i+"].childrenAges["+j+"]="+this.beanPeticioConsulta.getEdatNin(i,j);
			}
		}
		uri += "&asaReport=HomePage::City";
		uri += "&destinationId="+getCodiCiutat();
		uri += "&searchParams.landmark=";
		uri += "&hotelId=";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.hoteles.com" + Er.getValueWithNL("<meta http-equiv=\"Refresh\" content=\"0; url=([^\"]*)\"",resposta);
    	uri = uri.replaceAll("&amp;", "&");

		pfc.http.HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_2 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);
		resposta = this.getCompletePage(resposta);

		/* ********************************************** */
		//PETICIONS PER A TOTES LES PAGINES DE RESULTATS
		String next = Er.getOptionalValue("<a id=\"lnk_nextPageBottom\" href=\"([^\"]+)\"",resposta);
		while (next!=null){
			uri = "http://www.hoteles.com/" + next;

			pfc.http.HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
			HttpGet peticio_paginacio = new HttpGet(uri);
			String pagResposta = httpClient.execute(peticio_paginacio,responseHandler,httpContext);
			resposta += this.getCompletePage(pagResposta);			
			next = Er.getOptionalValue("<a id=\"lnk_nextPageBottom\" href=\"([^\"]+)\"",pagResposta);
		}

		//debug de l'html de la resposta completa (Totes les pagines)
		pfc.util.FileUtil.logResponseHTML(
			resposta, 
			pfc.conf.Constants.sDf.format(Calendar.getInstance().getTime())+pfc.conf.Constants.FILE_SEP+beanPeticioConsulta.getId(),
			CLASS_NAME + "#" + (iteracio++) + ".html");

		resultatScraping = resposta;
	}
	
	protected void getScrapedItems(){
		Vector<HotelBean> vHotelBean = new Vector<HotelBean>();

		Vector<String> items = Er.getValues("<li class=\"hotel(?: top_offer)?\">.+?</li>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item["+(++indexItem)+"/"+items.size()+"]");
			pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

			HotelesdotcomBean hotelesdotcomBean = new HotelesdotcomBean(beanPeticioConsulta);

			//Nom hotel
			String nomHotel = Er.getValueWithNL("<a.*?>(.+?)</a>",item);
			hotelesdotcomBean.setNomHotel(nomHotel);

			//Zona
			String zona = Er.getValueWithNL("<div class=\"desc area_data\">(.+?)</div>",item);
			zona = Er.replaceTagsAndTrim(zona);
			hotelesdotcomBean.setZona(zona.trim());

			//Categoria
			String categoria = Er.getOptionalValue("(\\d+) estrellas</span>",item);
			if (categoria != null) categoria = categoria.trim();
			hotelesdotcomBean.setCategoria(categoria);

			//Preu
			String preu = null;
			preu = Er.getOptionalValue("<ins>(.*?)</ins>",item);
			if (preu == null) {
				preu = Er.getValueWithNL("class=\"price\">\\s*<span>(.*?)</span>",item);
			}
			//Es substitueix el punt que s'utilitza com a separador de digits (1,150=>1150)
			preu = preu.replaceAll("[\\.]", "");
			preu = preu.replaceAll("[^0-9,]","");
			hotelesdotcomBean.setPreu(preu);

			//Insercio del registre al vector de resultats
			vHotelBean.add(hotelesdotcomBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vHotelBean);
	}

}