package pfc.wrapper.hotel.hotels;

import java.io.IOException;
import java.util.Calendar;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.log4j.Level;

import pfc.bean.hotel.HotelBean;
import pfc.bean.hotel.HotelopiaBean;
import pfc.util.Er;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;

/** pfc.wrapper.hotel.hotels.Hotelopia
 * 
 * Wrapper de l'operador hotelopia
 */
public class Hotelopia extends pfc.wrapper.hotel.WrapperHotel {
	
	public Hotelopia(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumHabitacions()>5)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ROOM);
		if (this.beanPeticioConsulta.getMaxAdults(13)>6)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ADULTS);
		if (this.beanPeticioConsulta.getMaxNins(13)>4)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_NINS);
	}

	protected String getCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Sevilla ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "Cordoba ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga Ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma centro ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Mahon";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Las Palmas";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Tenerife Zona Centro";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Girona ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "A Corua ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "Logroo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid centro";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Pamplona";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria Gasteiz";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian ciudad";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao ciudad";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected String getCodiCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "376567";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "375964";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "376228";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "375901";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "376172";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "376700";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "375914";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "376243";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "376336";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "370608";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "376143";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "376049";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "376574";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "376516";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "375567";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "375747";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "368251";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "376533";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "376682";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "368226";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "375875";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "371222";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "370178";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "375731";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "376469";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "376640";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "376047";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "386705";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "370701";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "376427";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "370796";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "375833";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "370781";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.hotelopia.es/TaskManager/resultHandler.ashx?";
		uri += "noCache=" + Calendar.getInstance().getTimeInMillis();
		uri += "&todayOffset=1";
		uri += "&_dest=" + "results.aspx";
		uri += "&textDestination=" + pfc.conf.Util.encode(this.getCiutat());
		uri += "&IdSearcher=" + this.getCodiCiutat();
		uri += "&date_in=" + this.getDataInici("dd/MM/yyyy");
		uri += "&date_out=" + this.getDataFi("dd/MM/yyyy");
		//Es important conservar el format original
		//Si el dia d'entrada enlloc de ser '07' es '7' la consulta ja no funciona!!
		uri += "&DayIn=" + this.getDataInici("dd");
		uri += "&MonthIn=" + this.getDataInici("MM");
		uri += "&YearIn=" + this.getDataInici("yyyy");
		uri += "&DayOut=" + this.getDataFi("dd");
		uri += "&MonthOut=" + this.getDataFi("MM");
		uri += "&YearOut=" + this.getDataFi("yyyy");
		uri += "&RO=" + this.beanPeticioConsulta.getNumHabitacions();
		uri += "&advanced=true";
		uri += "&free_hotel_name="; //Filtre per nombre d'hotel
		uri += "&RangMin=1";
		uri += "&RangMax=30";
		uri += "&BookToday=true";
		uri += "&quiet=true";
		uri += "&day_in=" + this.getDiaInici();
		uri += "&month_year_in=" + this.getDataInici("yyyy-MM");
		uri += "&day_out=" + this.getDiaFi();
		uri += "&month_year_out=" + this.getDataFi("yyyy-MM");

 		int numHabitacions = this.beanPeticioConsulta.getNumHabitacions();
 		for (int i=1; i<=5; i++){
 			if (i<=numHabitacions) {
 				uri += "&HA"+i+"=" + this.beanPeticioConsulta.getNumAdultsHabitacio(i-1,13);
 				uri += "&HN"+i+"=" + this.beanPeticioConsulta.getNumNinsHabitacio(i-1,13);
				for (int j=1; j<=4; j++){
 					uri += "&H" + i + "AG" + j + "=" + ((j<=this.beanPeticioConsulta.getNumNinsHabitacio(i-1,13))?this.beanPeticioConsulta.getEdatNin(i-1,j-1,13):"0");
 				}
 			}
 			else {
 				uri += "&HA"+i+"=0";
 				uri += "&HN"+i+"=0";
				for (int j=1; j<=4; j++){
 					uri += "&H" + i + "AG" + j + "=0";
 				}
 			}
 		} 		
 		uri += "&boardtype="; //filtre per tipus regim

 		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpPost]:" + uri);
		HttpPost peticio_1 = new HttpPost(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		dormir(5000);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.hotelopia.es/results.aspx";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_2 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 3
		uri = "http://www.hotelopia.es/results.aspx?order=price_asc";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_3 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_3,responseHandler,httpContext);

		resultatScraping = resposta;
	}

	protected void getScrapedItems(){
		Vector<HotelBean> vHotelBean = new Vector<HotelBean>();

		Vector<String> items = Er.getValues("<li class=\"hotel[^\\n]*?\"[^\\n]*?id=\"result.*?\">.*?(<li>.*?</li>.*?)*</li>",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");
			pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

			HotelopiaBean hotelopiaBean = new HotelopiaBean(beanPeticioConsulta);

			//Nom hotel
			hotelopiaBean.setNomHotel(Er.getValueWithNL("<a.*?id=\"hotelname.*?>(.+?)</a>",item));

			//Categoria
			String categoria = Er.getOptionalValue("(?:/(\\d+)EST\\.gif)|(?:/HS(\\d+)\\.gif)",item);
			hotelopiaBean.setCategoria(categoria);

			//Descripcio
			String descripcio = Er.getValueWithNL("<p class=\"hotel_description.*?\">(.+?)</p>",item);
			descripcio = Er.replaceValue("(<strong>.*?</strong>)?",descripcio,"");
			hotelopiaBean.setDescripcio(descripcio.trim());

			Vector<String> habitacions = new Vector<String>();

			//Files de preus
			Vector<String> itemsPreus = Er.getValues("<tbody class=\"multi\">.*?Reservar",item);
			if (itemsPreus.size()>0) {
				//Cada possible reserva inclou mes d'una habitacio
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(indexItem)+"/"+items.size()+"] => Several rooms");
				String itemPreu = itemsPreus.get(0);
				Vector<String> vHabitacions = Er.getValues("<tr id=\"SYS_hotel_room_table\">.*?</tr>",itemPreu);
				for (String habitacio: vHabitacions) {
					Vector<String> vColumnes = Er.getValues("<td.*?>(.*?)</td>",habitacio);
					if (vColumnes.size()>0) {
						//habitacio / regim
						String descHabitacio = Er.replaceContentTagsAndTrim(vColumnes.get(1).trim());
						descHabitacio = Er.replaceTagsAndTrim(descHabitacio);
						String descRegim =  vColumnes.get(2).trim();
						habitacions.add(descHabitacio + " (" + descRegim + ")");
						break;
					}
				}
				//Preu
				String preu = Er.getValueWithNL("<strong>([^]*)<",itemPreu);
				preu = Er.replaceTagsAndTrim(preu);
				preu = Er.replaceValue("[\\.]",preu,"");
				hotelopiaBean.setPreu(preu);
			}
			else {
				//Cada possible reserva inclou una habitacio
				loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(indexItem)+"/"+items.size()+"] => One room");
				Vector<String> vHabitacions = Er.getValues("tbody.*?<tr id=\"SYS_hotel_room_table\">.*?</tr>",item);
				String habitacio = vHabitacions.firstElement();
				Vector<String> vColumnes = Er.getValues("<td.*?>(.*?)</td>",habitacio,1);
				//habitacio / regim
				String descHabitacio = Er.replaceContentTagsAndTrim(vColumnes.get(0).trim());
				descHabitacio = Er.replaceTagsAndTrim(descHabitacio);
				String descRegim     = vColumnes.get(1).trim();
				habitacions.add(descHabitacio + " (" + descRegim + ")");
				String preu = vColumnes.get(4);
				preu = Er.replaceTagsAndTrim(preu);
				preu = Er.replaceValue("[\\.]",preu,"");				
				hotelopiaBean.setPreu(preu);
			}
			hotelopiaBean.setHabitacions(habitacions);

			//Insercio del registre al vector de resultats
			vHotelBean.add(hotelopiaBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vHotelBean);
	}

}