package pfc.wrapper.hotel.hotels;

import java.io.IOException;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.log4j.Level;

import pfc.bean.hotel.HotelBean;
import pfc.bean.hotel.LastminuteBean;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.hotel.hotels.Lastminute
 * 
 * Wrapper de l'operador lastminute
 */
public class Lastminute extends pfc.wrapper.hotel.WrapperHotel {
	
	public Lastminute(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumHabitacions()>3)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ROOM);
		if (this.beanPeticioConsulta.getMaxAdults(13)>4)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ADULTS);
		if (this.beanPeticioConsulta.getMaxNins(13)>2)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_NINS);
		if (this.beanPeticioConsulta.getNits()>28)
			throw new PeticioWrapperException(PeticioWrapperException.RANG_DATES);
	}

	protected String getCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "sevilla";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "almeria";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "cordoba";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "granada";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "malaga";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "zaragoza";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "huesca";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "oviedo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "palma de mallorca";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "ibiza";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "mahon";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "las palmas";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "santa cruz de tenerife";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "santander";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "albacete";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "burgos";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "leon";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "salamanca";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "valladolid";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "barcelona";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "girona";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "valencia";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "alicante";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "badajoz";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "la corua";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "vigo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "logroo";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "madrid";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "murcia";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "pamplona";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "vitoria";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "san sebastian";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "bilbao";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		//PETICIO 1
		uri = "http://www.es.lastminute.com/site/viajes/hoteles/";

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		//PETICIO 2
		uri = "http://www.es.lastminute.com/trips/interstitial/searchHotels?";
		uri += "skin=eses.lastminute.com";
		uri += "&configId=" + Er.getValue("<input type=\"hidden\" name=\"configId\" value=\"([^\"]+)\"",resposta);
		uri += "&filterResultsBy=all";
		uri += "&returnURL=http://www.es.lastminute.com/site/travel/hotels/esRebrand_homepage.html";
		uri += "&errorURL=http://www.es.lastminute.com/site/viajes/hoteles/error.html";
		uri += "&preserveName-skin=eses.lastminute.com";
		uri += "&preserveName-CATEGORY=hotels";	
		uri += "&preserveName-partnerId=0";
		uri += "&preserveName-SEARCH=basic";
		uri += "&preserveName-requestURL=/site/viajes/hoteles/esRebrand_homepage.html";
		uri += "&lmnShowRestaurants=False";
		uri += "&searchTypeName=cityName";
		uri += "&lmnLocation=" + pfc.conf.Util.encode(getCiutat());
		uri += "&method=hotelsFullSearch";
		uri += "&lmnCountry=Any";
		uri += "&lmnCheckInDay=" + this.getDiaInici();
		uri += "&lmnCheckInMonth=" + this.getMesInici();
		uri += "&lmnLengthOfStay=" + this.beanPeticioConsulta.getNits();
		uri += "&lmnCheckOutDisplay=" + this.getDataFi("dd+MMMM");
		uri += "&lmnCheckOutDay=" + this.getDiaFi();
		uri += "&lmnCheckOutMonth=" + this.getMesFi();
		uri += "&lmnRooms=" + String.valueOf(this.beanPeticioConsulta.getNumHabitacions());
		for (int i=1; i<=3; i++) {
			if (i<=this.beanPeticioConsulta.getNumHabitacions()){
				uri += "&lmnAdultsRoom" + i + "=" + this.beanPeticioConsulta.getNumAdultsHabitacio(i-1,13);
				uri += "&lmnChildrenRoom" + i + "=" + this.beanPeticioConsulta.getNumNinsHabitacio(i-1,13);
				int numNins = this.beanPeticioConsulta.getNumNinsHabitacio(i-1,13);
				for (int j=1; j<=4; j++) {
					uri += "&lmnRoom" + i + "ChildAge" + j + "=";
					if (j<=numNins) {
						uri += this.beanPeticioConsulta.getEdatNin(i-1,j-1,13);
					}
				}
			} else {
				uri += "&lmnAdultsRoom" + i + "=";
				uri += "&lmnChildrenRoom" + i + "=0";
				for (int j=1; j<=4; j++) {
					uri += "&lmnRoom" + i + "ChildAge" + j + "=";
				}				
			}
		}

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_2 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_2,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 3
		uri = "http://www.es.lastminute.com/" + Er.getValue("<meta http-equiv=\"refresh\" content=\"0;url=([^\"]+)\"",resposta);
		uri = uri.replaceAll("&amp;","&");

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_3 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_3,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 4
		uri = "http://www.es.lastminute.com/" + Er.getValue("<a.*href='([^']+)'>Menor precio</a>",resposta);
		uri = uri.replaceAll("&amp;","&");

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_4 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_4,responseHandler,httpContext);

		resultatScraping = resposta;
	}
	
	protected void getScrapedItems() {
		Vector<HotelBean> vHotelBean = new Vector<HotelBean>();

		Vector<String> items = Er.getValuesAndBack(
			"<div class=\"product available \">.*?(<div class=\"product available \">|<div class=\"end-of-list\"></div>)",
			resultatScraping,
			"<div class=\"product available \">".length()
		);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");
			pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

			LastminuteBean lastminuteBean = new LastminuteBean(beanPeticioConsulta);

			//Nom hotel
			String nomHotel = Er.getValueWithNL("class=\"to-hotel-information\".*?>(.*?)<",item);
			lastminuteBean.setNomHotel(nomHotel);

			//Zona
			String zona = Er.getOptionalValue("area-name\">(.+?)<",item);
			if (zona!=null) zona = zona.trim();
			lastminuteBean.setZona(zona);

			//Categoria
			String categoria = Er.getValue("\"(\\d+) estrella",item);
			lastminuteBean.setCategoria(categoria);

			//Direccio
			String direccio = Er.getValueWithNL("hotel-location-information\">(.*?)</div",item);
			lastminuteBean.setDireccio(direccio.trim());

			//Descripcio
			String descripcio = Er.getValueWithNL("text\">(.*?)</li",item);
			Vector<String> vHrefs = Er.getValues("href=\"(.*?)\"",descripcio,1);
			for (String href: vHrefs){
				//Escapament de caracters especials que poden formar part d'expressions regulars
				href=href.replaceAll("\\?","\\\\?");
				descripcio = descripcio.replaceAll(href, "http://lastminute.com"+href);
			}
			lastminuteBean.setDescripcio(descripcio.trim());

			//Preu
			String preu = null;
			preu = Er.getOptionalValue("(?:class=\"number (?:\\s+highlight)?\">\\s*([\\d,.]+))|(?:strike\">\\s*[\\d,.]+)",item);
			lastminuteBean.setPreu(preu.replaceAll("[^\\d\\,]", ""));

			//Insercio del registre al vector de resultats
			vHotelBean.add(lastminuteBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vHotelBean);
	}

}