package pfc.wrapper.hotel.hotels;

import java.io.IOException;
import java.util.Vector;

import org.apache.http.client.methods.HttpGet;
import org.apache.log4j.Level;

import pfc.bean.hotel.HotelBean;
import pfc.bean.hotel.SkooshBean;
import pfc.exception.PeticioWrapperException;
import pfc.http.HttpLog;
import pfc.util.Er;

/** pfc.wrapper.hotel.hotels.Skoosh
 * 
 * Wrapper de l'operador skoosh
 */
public class Skoosh extends pfc.wrapper.hotel.WrapperHotel {
	
	public Skoosh(){
		super();
	}

	protected void assertPeticioWrapper() throws PeticioWrapperException {
		if (this.beanPeticioConsulta.getNumHabitacions()>5)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ROOM);
		if (this.beanPeticioConsulta.getMaxAdults(19)>6)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_ADULTS);
		if (this.beanPeticioConsulta.getMaxNins(19)>2)
			throw new PeticioWrapperException(PeticioWrapperException.MAX_NINS);
	}

	protected String getCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "Seville (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "Almeria (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "Cordoba (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "Granada (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "Malaga (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "Zaragoza (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "Huesca (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "Oviedo (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "Palma De Mallorca (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "Ibiza (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "Mahon (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "Las Palmas (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "Santa Cruz De Tenerife (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "Santander (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "Albacete (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "Burgos (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "Leon (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "Salamanca (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "Valladolid (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "Barcelona (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "Girona (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "Valencia (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "Alicante (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "Badajoz (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "A Corua (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "Vigo (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "Logrono (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "Madrid (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "Murcia (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "Pamplona (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "Vitoria (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "San Sebastian (Spain)";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "Bilbao (Spain)";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	private String getCodiCiutat() throws PeticioWrapperException {
		String ciutat = this.beanPeticioConsulta.getDesti();
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SEVILLA))		return "39";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALMERIA))		return "380";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORDOBA))		return "66";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GRANADA))		return "70";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MALAGA))		return "86";		
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ZARAGOZA))	return "726";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_HUESCA))		return "4323";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_OVIEDO))		return "2940";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PALMA)) 		return "1790";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_IBIZA)) 		return "708";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MENORCA))		return "7676";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LASPALMAS))	return "2425";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_TENERIFE))	return "7936";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANTANDER))	return "721";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALBACETE))	return "4561";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BURGOS)) 		return "1070";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LEON)) 		return "711";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SALAMANCA))	return "720";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALLADOLID)) 	return "1111";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BARCELONA)) 	return "30";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_GIRONA)) 		return "1076";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VALENCIA))	return "111";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_ALICANTE))	return "1066";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BADAJOZ)) 	return "3094";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_CORUNYA)) 	return "2488";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VIGO)) 		return "1112";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_LOGRONO)) 	return "1080";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MADRID)) 		return "20";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_MURCIA)) 		return "1008";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_PAMPLONA)) 	return "716";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_VITORIA)) 	return "3116";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_SANSEBASTIAN))return "1097";
		if (ciutat.equals(pfc.conf.Ciutats.CIUTAT_BILBAO)) 		return "183";
		throw new PeticioWrapperException(PeticioWrapperException.CIUTAT_NO_CONFIGURADA.replaceAll("\\{0\\}", ciutat));
	}

	protected void getScrapedData() throws PeticioWrapperException,IOException
	{
		//INICIALITZACIONS
		String resposta = null;
		String uri = null;

		/* ********************************************** */
		//PETICIO 1
		uri = "http://www.skoosh.es/s/twibo/check.html?";
		uri += "city_id=" + getCodiCiutat();
		uri += "&__date_format=euro:check_in_date,check_out_date";
		uri += "&filter_an="; //Per a hotels cercans a atraccions
		uri += "&attraction_specified="; //Per a hotels cercans a atraccions
		uri += "&city_specified=" + pfc.conf.Util.encode(getCiutat());
		uri += "&check_in_date=" + this.getDataInici("dd/MM/yy");
		uri += "&check_out_date=" + this.getDataFi("dd/MM/yy");
		uri += "&nights=" + this.beanPeticioConsulta.getNits();
		uri += "&currency_name=EUR"; //Es pot indicar la moneda en la que es mostren els preus
		int numHabitacions = this.beanPeticioConsulta.getNumHabitacions();
		uri += "&rooms=" + String.valueOf(this.beanPeticioConsulta.getNumHabitacions());
		for (int i=1; i<=5; i++){
			if (i<=numHabitacions) {
				uri += "&adults_" + i + "=" + this.beanPeticioConsulta.getNumAdultsHabitacio(i-1,19);
				uri += "&child_"  + i + "=" + this.beanPeticioConsulta.getNumNinsHabitacio(i-1,19);
				int numChildren = this.beanPeticioConsulta.getNumNinsHabitacio(i-1,19);
				for (int j=1; j<=2; j++){
					uri += "&child_"  + i + "_" + j + "=" + ((j<=numChildren)?this.beanPeticioConsulta.getEdatNin(i-1,j-1,19):"none");
				}
			}
			else {
				uri += "&adults_" + i + "=0";
				uri += "&child_"  + i + "=0";
				for (int j=1; j<=2; j++){
					uri += "&child_"  + i + "_" + j + "=none";
				}
			}
		}

		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_1 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_1,responseHandler,httpContext);

		/* ********************************************** */
		//PETICIO 2
		uri = "http://www.skoosh.es/" + Er.getValue("url:[ ]*\"([^\"]+)\"",resposta);
		int attempt = 0;
		String scrapedID = null;
		while (scrapedID==null && attempt <20){
			attempt++;
			dormir(700);

			HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + (uri+attempt));
			HttpGet peticio_ajax = new HttpGet(uri+attempt);
			resposta = httpClient.execute(peticio_ajax,responseHandler,httpContext);
			scrapedID = Er.getOptionalValue("search_id\":\"([^\"]+)\",\"ready\":1",resposta);
		}

		/* ********************************************** */
		//PETICIO 3
		uri = "http://www.skoosh.es/s/twibo/results.html?result_id="+scrapedID;
		
		HttpLog.log("["+beanPeticioConsulta.getId() + "][HttpGet]:" + uri);
		HttpGet peticio_3 = new HttpGet(uri);
		resposta = httpClient.execute(peticio_3,responseHandler,httpContext);

		resultatScraping = resposta;
	}
	
	protected void getScrapedItems(){
		Vector<HotelBean> vHotelBean = new Vector<HotelBean>();

		Vector<String> items = Er.getValues("class=\"(table double_col detail width530|table_full_width)\" style=\"\">.*?<div class=\"spacer2\">",resultatScraping);
		loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());
		System.out.println("["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" items found "+items.size());

		int indexItem=0;
		for (String item: items){

			loger.log(Level.DEBUG,"["+this.beanPeticioConsulta.getId()+"] "+CLASS_NAME+" item ["+(++indexItem)+"/"+items.size()+"]");
			pfc.util.FileUtil.printItemHotel(item, CLASS_NAME+"#item_" + indexItem + ".html");

			SkooshBean skooshBean = new SkooshBean(beanPeticioConsulta);

			//Nom hotel
			skooshBean.setNomHotel(Er.getValue("<a.*>(.+?)</a>",item));

			//Categoria
			skooshBean.setCategoria(Er.getOptionalValue("Stars/(\\d+)",item));

			//Descripcio
			String descripcio = Er.getValueWithNL("<p class=\"v2\">(.+?)</p>",item);
			Vector<String> vHrefs = Er.getValues("href=\"(.*)\"",descripcio,1);
			for (String href: vHrefs){
				descripcio = Er.replaceValue(href,descripcio,"http://www.skoosh.com"+href);
			}
			skooshBean.setDescripcio(descripcio);

			//Descripcio habitacions
			Vector<String> vDescHabs = new Vector<String>();
			for (int iHab=1; iHab<=beanPeticioConsulta.getNumHabitacions(); iHab++){
				String descHab = Er.getValueWithNL(iHab+" de habitaci.*?<p class=\"v2\">(.*?)</p>",item);
				if (descHab!=null) {
					vDescHabs.add(Er.replaceContentTagsAndTrim(descHab));
				}
				else break;
			}
			skooshBean.setvDescHab(vDescHabs);

			//Preu
			skooshBean.setPreu(Er.getValue("class=\"size120\">(\\d+\\.\\d+)",item));

			//Insercio del registre al vector de resultats
			vHotelBean.add(skooshBean);
		}
		resultatItemsScraping = new Vector<pfc.bean.ItemBean>(vHotelBean);
	}

}